#include <iostream>
#include <ctime>
#include <windows.h>
#include<fstream>
#include<cstdlib>
#include<conio.h>
using namespace std;
 
int i, j;
char Sudoku[9][9];
char player[9][9];
void filling();
void spaces(int run);
void display();
void turn();
int error(int row, int column, char userturn);
int check();
void won();
void errormsg();
void clear_screen();
 
 
int main(void)
{
     int run;
    char back = 'y';
   
    while(back == 'y' || back == 'Y')
    {
         clear_screen();
         cout << "Welcome To IIT Sudoku Game\n";
         filling();    //Sudoku is provided.... 
         turn();       // This will let the user get into the real game
         cout << endl;
         cout << "Want to play sudoku again(y/n)? ";
         cin >> back;
    }
} 
void turn()
{
     for (i=0;i<9;i++)
     for (j=0;j<9;j++)
     player[i][j] = Sudoku[i][j];
     char userturn;
     int row, column;
     bool gamewin = false;
     
     while(!gamewin){
     clear_screen();
     display();  // Nice Display Board
     cout << "\nEnter row , column number & your number with space in between them: ";
     cin >> row >> column >> userturn;
     
     
     if(!(error(row, column, userturn))){  // Error Checking
         errormsg();
         continue;
         }
     
     player[row-1][column-1] = userturn;
     if(Sudoku[row-1][column-1] != ' '){ // User can't edit the numbers given by computer already
         errormsg();
         player[row-1][column-1] = Sudoku[row-1][column-1];
         continue;
     }
     
     if (check()){ // Checking the winning condition for user
        won();
        gamewin = true;
     }
     }
}
void filling()
{   
    char ch;
    int spaces;
    ifstream f1;
    ifstream f2;
    ofstream f3;
    ofstream f4;
    srand(time(0));     
    cout<<"Sudoku game"<<endl;     
    char sudsolved[18];
    strcpy(sudsolved,"sudokusolved");
    sudsolved[12]=rand()%10+1+48;
    cout<<"Sudoku number :- "<<sudsolved[12]<<endl;
    sudsolved[13]='.';
    sudsolved[14]='t';
    sudsolved[15]='x';
    sudsolved[16]='t';
    sudsolved[17]='\0';
    f2.open(sudsolved);
    for(i=0;i<9;i++)
    {
        for(j=0;j<9;j++)
        {
              ch=f2.get();
              if(f2.eof())
                   break;
              if(ch!='\n')
              Sudoku[i][j]=ch;                                  
              else
              j--;
        }  
    }
    char solsudoku[13];
    strcpy(solsudoku,"Solutionsudoku.txt\0");
    f4.open(solsudoku);
    for(i=0;i<9;i++)
    {
         cout<<endl;
         f4<<endl;
         for(int j=0;j<9;j++)
         {
             f4<<Sudoku[i][j]<<"  ";
             cout<<Sudoku[i][j]<<"  ";
         }
    }
    f4.close();
    f2.close();
    cout<<endl;
    cout<<"Please enter total number of spaces you would like"<<endl;
    cin>>spaces;
    while(spaces>40)
    {
    cout<<"Please enter a valid entry"<<endl;
    cin>>spaces;
    }
    while(spaces>0 && spaces<40)
    {
        int row=rand()%9;
        int col=rand()%9;
        if(Sudoku[row][col]!=0)
        {
          Sudoku[row][col]=0;
          spaces--;
        }
    }
   
        cout<<"Unsolved Sudoku for user  ";   
        char playersud[17];
        strcpy(playersud,"playersudoku.txt\0");
        f3.open(playersud);
        for(i=0;i<9;i++)
        {
            
            cout<<endl;
            for(j=0;j<9;j++)
            {
                 f3<<Sudoku[i][j]<<"  ";
                 cout<<Sudoku[i][j]<<"  ";
            }
            f3<<endl;
        }
        f3.close();
}
 
void display()
{
     cout << "    1 2 3  |  4 5 6  |  7 8 9\n"
          << "--------------------------------\n\n";
   for (int k = 3;k<=9;k+=3){
     for (i = k-3;i<k;i++){
            cout << i+1 << "|  ";
         for (j = 0;j<3;j++){
             cout <<player[i][j] << " ";
             }
         cout << " |  ";
         
     for (j=3;j<6;j++){
         cout <<player[i][j] << " ";
         }
         cout << " |  ";
         
     for (j=6;j<9;j++){
         cout <<player[i][j] << " ";
         }
         cout << " |  ";  
           
     cout << endl;
     }
     cout << endl << "--------------------------------\n\n";
     }
}
 
int error(int row, int column, char userturn)
{
     if(!(row <=9  && row >=1) || !(column <=9  && column >=1) )
              return 1;
     
     
     for (int j = 0;j<9;j++){ // Error if user try to write number already exist in the same line
         if(j != column-1){
              if(userturn == Sudoku[row-1][j]){
                          return false;
                          break;
     }}}
     for (int i = 0;i<9;i++){
         if(i != row-1){
              if(userturn == Sudoku[i][column-1]){
                          return false;
                          break;
     }}}  
         
     return true;                                              
}
 
bool check()
{
     for(i=0;i<9;i++){
         for (j=0;j<9;j++){
             if (player[i][j] == ' ')
             return false;
             }}
     return true;
 }
 
void won()
{
     cout << "\nCongratulation, You have completed the Sudoku Game";
}
 
void errormsg()
{
     cout << "\nIncorrect Move\n";
     system("pause");
}
 
void clear_screen()
{
        HANDLE output_handle = GetStdHandle(STD_OUTPUT_HANDLE);
        DWORD bytes_write, size;
        COORD coord = {0, 0};
        CONSOLE_SCREEN_BUFFER_INFO csbi;
 
        GetConsoleScreenBufferInfo(output_handle, &csbi);
       
        size = csbi.dwSize.X * csbi.dwSize.Y;
       
        FillConsoleOutputCharacter(output_handle, ' ', size, coord, &bytes_write);
        SetConsoleCursorPosition(output_handle, coord);
}
 
 
