#include"ezwin.h"
#include"rect.h"
#include"cstdio"
#include<cstring>
#include<cstdlib>



int mouseclick(const Position &);//mouseclick for EzWindow Sudoku
int mouseclick1(const Position &);//Allocates coordinates of the region of mouse click in EZwindow startgame
int mouseclick2(const Position &);//Allocates coordinates of the region of mouse click in EZwindow startgame and switches to EzWindow solver

SimpleWindow sudoku1("Start Game",16,10,Position(5,5));//Allocates position to the user interface command
SimpleWindow sudoku2("Solver",16,10,Position(5,5));// EzWindow for user to provide an unsolved sudoku which our program is supposed to solve.
SimpleWindow sudoku3("Solve",9,9,Position(5,5)); // EzWindow for showing message to user



void write();//copies question array in another array
 
SimpleWindow sudoku("Sudoku",16,10,Position(5,5));//Ezwindow for sudoku grid which gives question sudoku to user and enables him to solve it
int ansarray[9][9];
int sudoku_array[9][9];
int quesarray[9][9];
char array[9][9][2];
char array1[9][9][2];
#include"write.h"//writes values of question sudoku on EzWindow Screen
#include"write1.h"//writes values of question sudoku on EzWindow Screen
#include"write3.h"//writes values of question sudoku on EzWindow Screen
#include"sudo.h"//switches to window which shows a message for user

float  xclick,yclick,size;

int ApiMain()//main interface programming body 
{
	sudoku1.Open();
	
	RectangleShape NewGame(sudoku1,Position(8,3),Yellow,8,2);
	NewGame.Draw();
	sudoku1.RenderText(Position(8,3),"Play Game",Red,Yellow);
	RectangleShape NewGame1(sudoku1,Position(8,6),Yellow,8,2);
	NewGame1.Draw();
	sudoku1.RenderText(Position(8,6),"Solver",Red,Yellow);
	sudoku1.SetMouseClickCallback(mouseclick1);
	
	return 0;
}	

int mouseclick1(const Position &p)//Allocates coordinates of the region of mouse click in EZwindow startgame
{	
	xclick=p.GetXDistance();
	yclick=p.GetYDistance();
	
	
	int ixclick=xclick;
	int iyclick=yclick;
	if ((ixclick>=4 && ixclick<12) && (iyclick>=2 && iyclick<4))
	{
	    
	    
	    sudoku.Open();            // opening Ezwindow
	    float size;
	    FILE *fp;
	    fp=fopen("playersudoku.txt","r");
	    if(fp==NULL)
	    {
	         cout<<"no.\n";
	         return 1 ;
        }
	    for(int i=0;i<9;i++)
	    {
		     for (int j=0;j<9;j++)
		     {
			      fscanf(fp,"%d",&quesarray[j][i]);
	         }
        }
        for(int i=0;i<9;i++)
        {
		     for(int j=0;j<9;j++)
		     {
	             sudoku_array[i][j]=0;
			     ansarray[i][j]=0;
			     sudoku_array[i][j]=quesarray[i][j];
			     sprintf(array[i][j],"%d",sudoku_array[i][j]);
			 }
	    }
        for(int x=0;x<=9;x++)
        {	
		     if(x%3==0)
		     size=0.2;
		     else
		     size=0.0;
		     sudoku.RenderLine(Position(x,0),Position(x,9),Black,size);
         }
	     for(int y=0;y<=9;y++)
	     {	
		     if(y%3==0)
		     size=0.2;
		     else
		     size=0.0;
		     sudoku.RenderLine(Position(0,y),Position(9,y),Black,size);
         }
	
	     RectangleShape solution(sudoku,Position(11,5),Yellow,2,2);
	     solution.Draw();
	     sudoku.RenderText(Position(11,5),"SOLUTION",Black,Yellow);
	
	     write();
	     sudoku.SetMouseClickCallback(mouseclick);
	    
    }
	
	if ((ixclick>=4 && ixclick<12) && (iyclick>=5 && iyclick<7))
	{
	    sudoku2.Open();
        for(int x=0;x<=9;x++)
       	{	
       	     if(x%3==0)
             size=0.2;
             else
             size=0.0;
	         sudoku2.RenderLine(Position(x,0),Position(x,9),Black,size);
        }
   	    for(int y=0;y<=9;y++)
        {	
			 if(y%3==0)
			 size=0.2;
			 else
			 size=0.0;
			 sudoku2.RenderLine(Position(0,y),Position(9,y),Black,size);
        }
	    RectangleShape Solve_button(sudoku2,Position(11,5),Yellow,2,2);
	    Solve_button.Draw();
	    sudoku2.RenderText(Position(11,5),"Solve It",Black,Yellow);
        sudoku2.SetMouseClickCallback(mouseclick2);
	}
}







int mouseclick(const Position &p)            //mouseclick for EzWindow Sudoku
{	
	xclick=p.GetXDistance();
	yclick=p.GetYDistance();
	
	
	int ixclick=xclick;
	int iyclick=yclick;
	if((ixclick>=0 && ixclick<9) && (iyclick>=0 && iyclick<9))
	{	
		if (quesarray[ixclick][iyclick]==0)
		{
		cout<<"Enter array number"<<"array["<<ixclick<<"]["<<iyclick<<"]"<<endl;
		cin>>sudoku_array[ixclick][iyclick];
		sprintf(array[ixclick][iyclick],"%d",sudoku_array[ixclick][iyclick]);
		write();
		}
	
	}
    
    
	if((ixclick>=10 && ixclick<12) && (iyclick>=4 && iyclick<6))
	{
	  
	  FILE *fp1;
	  char str[9][9];
	  int c;
	  c=1;
	  fp1=fopen("Solutionsudoku.txt","r");
	  if(fp1==NULL)
	  {
	   cout<<"Could not open the file.\n";
	   return 1;
	  }
	  

          int flag=0;
          
          fgets(str,80,fp1);
          while(!feof(fp1))
          {
            for(int i=0;i<9;i++)
            { 
             for(int j=0;j<9;j++)
             {
             
              if((str[i][j]-48)!=sudoku_array[i][j])
              {
                flag=1;
                
              }
             }
            }
                
            
         }
       int k=0;
       
     while(!feof(fp1))
     {
      fgets(str[k],80,fp1);       
       k++;
     }
     
    /* for(int i=0;i<9;i++)
     {  
      for(int j=0;j<9;j++)
      {
        str[i][j]=str[i][j]-48;
      }
      
     }
    */ 
      
      
      
      
      
      for(int i=0;i<9;i++)
      {  
      for(int j=0;j<9;j++)
      {
     /*     if( strcmp(str[i][j],sudoku_array[i][j])!=0)
          {
               flag=1;
               //break;
           }
                */      
           cout<<str[i][j]<<'\t';
       }
       cout<<'\n';
     }          
          
               
          if(flag==1)
          {sudoku.RenderText(Position(11,2),"NOT CORRECT",Black,Yellow);}
          else
          {sudoku.RenderText(Position(11,2),"CORRECT",Black,Yellow);}
          
          
          fclose(fp1);
         
        }       
    
  }





int mouseclick2(const Position &p)
{
        xclick=p.GetXDistance();
	yclick=p.GetYDistance();
	
	
	int ixclick=xclick;
	int iyclick=yclick;
	
	if((ixclick>=0 && ixclick<9) && (iyclick>=0 && iyclick<9))
	{
		cout<<"Enter array number"<<"array["<<ixclick<<"]["<<iyclick<<"]"<<endl;
		cin>>sudoku_array[ixclick][iyclick];
		sprintf(array[ixclick][iyclick],"%d",sudoku_array[ixclick][iyclick]);
		write1();
        }
        
        
        if((ixclick>=10 && ixclick<12) && (iyclick>=4 && iyclick<6))
        {
          
               sudo();           
        }
        
}
